// Mereni AC proudu s mericim transformatorem proudu typ: SCT-013-000
// se zobrazenim na LCD se seriovou komunikaci. 
// Mereni proudu je ve trech fazich AC napeti 230VAC. 
// www.mojeelektronika.mzf.cz  vagnervlastimil@seznam.cz

#include <SoftwareSerial.h>                    // pripojeni knihovny pro kmunikaci  LCD displejem
#define txPin 2                                // definovani komunikacniho pinu s lcd displejem klidova uroven na lcd je nastavena na "T" vysoka 
SoftwareSerial LCD = SoftwareSerial(0, txPin); // pripojeni nastavenych parametru ke knihovně
const int LCDdelay=300;                        // nastaveni casove prodlevy pro lcd displej
#define L1_pinTrafo A0                         // nastaveni cisla PINU pro pripojeni vystupu snimaciho rezistoru faze L1
#define L2_pinTrafo A1                         // nastaveni cisla PINU pro pripojeni vystupu snimaciho rezistoru faza L2
#define L3_pinTrafo A2                         // nastaveni cisla PINU pro pripojeni vystupu snimaciho rezistoru faze L3
int prevod = 2000;                             // prevodni pomer transformatoru
float L1_odpor = 33.0;                         // zadani velikosti odporu L1
float L2_odpor = 33.0;                         // zadani velikosti odporu L2
float L3_odpor = 33.0;                         // zadani velikosti odporu L3
float L1_Spickovenapeti;                       // zadani merici promenne L1
float L2_Spickovenapeti;                       // zadani merici promenne L2
float L3_Spickovenapeti;                       // zadani merici promenne L3
float L1_Spickovyproud;                        // zadani merici promenne L1 
float L2_Spickovyproud;                        // zadani merici promenne L2
float L3_Spickovyproud;                        // zadani merici promenne L3
float L1_proudRMSnaRezistoru;                  // zadani merici promenne L1 
float L2_proudRMSnaRezistoru;                  // zadani merici promenne L2
float L3_proudRMSnaRezistoru;                  // zadani merici promenne L3
float L1_proudRMS;                             // zadani merici promenne L1 
float L2_proudRMS;                             // zadani merici promenne L2
float L3_proudRMS;                             // zadani merici promenne L3
float L1_celkem;                               // zadani merici promenne L1 
float L2_celkem;                               // zadani merici promenne L2
float L3_celkem;                               // zadani merici promenne L3

void setup(){
delay(1000);                                   // casova prodleva  
pinMode(L1_pinTrafo, INPUT);                   // nastaveni pinu A0 pro prevodnik s transformatoeem jako vstup L1
pinMode(L2_pinTrafo, INPUT);                   // nastaveni pinu A1 pro prevodnik s transformatorem jako vstup L2
pinMode(L3_pinTrafo, INPUT);                   // nastaveni pinu A2 pro prevodnik s transformatorem jako vstup L3
pinMode(txPin, OUTPUT);                        // nastaveni komunikacniho pinu na vystup
LCD.begin(2400);                               // nastaveni prenosove rychlosti
smazLCD();                                     // prikaz pro inicializaci lcd a smazani displeje
podsviceniOn() ;                               // zapnuti podsviceni displeje
kursorOff();                                   // vypnuti kursoru blikani
posunvpravo();                                 // nastaveni posunu znaku vpravo  
LCDpoziceznaku(0,2); LCD.print("Mereni AC proudu"); // nadpis
delay(100);                                         // casova prodleva pro displej
}

void loop(){
L1_Spickovenapeti = L1_NapetiSpickaSpicka();                   // ziskani napeti Spicka-spicka pomoci funkce 
L1_Spickovyproud = ((L1_Spickovenapeti / L1_odpor) * 1000.0);  // vypocet proudu v mA tekoucjho rezistorem pomoci Ohmova zakona
L1_proudRMSnaRezistoru = (L1_Spickovyproud * 0.707);           // vypocet RMS hodnoty proudu
L1_proudRMS = (L1_proudRMSnaRezistoru * prevod);               // vypocet mereneho proudu diky znalosti prevodniho pomeru 2000:1
L1_celkem = (L1_proudRMS / 1000);                              // prepocet z honoty mA pro zobrazeni "A" 0.134A
LCDpoziceznaku(1,0); LCD.print("L1 A: ");                      // nastaveni pozice prvniho znaku na prvnim radku
delay(100);                                                    // casova prodleva pro zapis znaku
if (L1_proudRMS <= 0 ){                                        // porovnani hodnoty pokud je nizssi nebo rovna "0" pokracuje na dalsim radku
LCDpoziceznaku(1,6); LCD.print("          ");}                 // vymazani znaku od pozice 0,6  
else{                                                          // pokud neni pravda pokracuje na dalsim radku
LCDpoziceznaku(1,6); LCD.print(L1_celkem,3);                   // nastaveni pozice vypoctu na prvnim radku vysledek na tri desetinna mista
delay(100);}                                                   // casova prodleva pro zapis znaku
L2_Spickovenapeti = L2_NapetiSpickaSpicka();                   // ziskani napeti Spicka-spicka pomoci funkce 
L2_Spickovyproud = ((L2_Spickovenapeti / L2_odpor) * 1000.0);  // vypocet proudu v mA tekoucjho rezistorem pomoci Ohmova zakona
L2_proudRMSnaRezistoru = (L2_Spickovyproud * 0.707);           // vypocet RMS hodnoty proudu
L2_proudRMS = (L2_proudRMSnaRezistoru * prevod);               // vypocet mereneho proudu diky znalosti prevodniho pomeru 2000:1
L2_celkem = (L2_proudRMS / 1000);                              // prepocet z honoty mA pro zobrazeni "A" 0.134A
LCDpoziceznaku(2,0); LCD.print("L2 A: ");                      // nastaveni pozice prvniho znaku na prvnim radku
delay(100);                                                    // casova prodleva pro zapis znaku
if (L2_proudRMS <= 0 ){                                        // porovnani hodnoty pokud je nizssi nebo rovna "0" pokracuje na dalsim radku
LCDpoziceznaku(2,6); LCD.print("          ");}                 // vymazani znaku od pozice 0,6  
else{                                                          // pokud neni pravda pokracuje na dalsim radku
LCDpoziceznaku(2,6); LCD.print(L2_celkem,3);                   // nastaveni pozice vypoctu na prvnim radku vysledek na tri desetinna mista
delay(100);}                                                   // casova prodleva pro zapis znaku
L3_Spickovenapeti = L3_NapetiSpickaSpicka();                   // ziskani napeti Spicka-spicka pomoci funkce 
L3_Spickovyproud = ((L3_Spickovenapeti / L3_odpor) * 1000.0);  // vypocet proudu v mA tekoucjho rezistorem pomoci Ohmova zakona
L3_proudRMSnaRezistoru = (L3_Spickovyproud * 0.707);           // vypocet RMS hodnoty proudu
L3_proudRMS = (L3_proudRMSnaRezistoru * prevod);               // vypocet mereneho proudu diky znalosti prevodniho pomeru 2000:1
L3_celkem = (L3_proudRMS / 1000);                              // repocet z honoty mA pro zobrazeni "A" 0.134A
LCDpoziceznaku(3,0); LCD.print("L3 A: ");                      // nastaveni pozice prvniho znaku na prvnim radku
delay(100);                                                    // casova prodleva pro zapis znaku
if (L3_proudRMS <= 0 ){                                        // porovnani hodnoty pokud je nizssi nebo rovna "0" pokracuje na dalsim radku
LCDpoziceznaku(3,6); LCD.print("          ");}                 // vymazani znaku od pozice 0,6  
else{                                                          // pokud neni pravda pokracuje na dalsim radku
LCDpoziceznaku(3,6); LCD.print(L3_celkem,3);                   // nastaveni pozice vypoctu na prvnim radku vysledek na tri desetinna mista
delay(5000);}                                                  // casova prodleva pred dalsim odectu proudu
}
float L1_NapetiSpickaSpicka(){                        
float L1_vysledek = 0;                                         // merici promenne
int L1_merenaHodnota = 0;                                      // merici promenne
int L1_maximum = 0;                                            // merici promenne
unsigned long zacatekMereni = millis();                        // ulozeni startovaciho casu
while ((millis() - zacatekMereni) < 1000){                     // mereni po dobu jedne sekundy 
L1_merenaHodnota = analogRead(L1_pinTrafo);                    // mereni napeti na odporu
if (L1_merenaHodnota > L1_maximum){                            // nalezeni maxima
L1_maximum = L1_merenaHodnota;                                 // ulozeni noveho maxima
  }
 }
L1_vysledek = ((L1_maximum * 5.0) / 1024);                     // prevod vysledku na napeti ve Voltech
L1_vysledek = (L1_vysledek - 2.500);                           // vypocet hodnoty o stejnosmerne napeti prevodniku 2.500V
return L1_vysledek;                                            // vraceni vysledku funkce
}
float L2_NapetiSpickaSpicka(){                        
float L2_vysledek = 0;                                         // merici promenne
int L2_merenaHodnota = 0;                                      // merici promenne
int L2_maximum = 0;                                            // merici promenne
unsigned long zacatekMereni = millis();                        // ulozeni startovaciho casu
while ((millis() - zacatekMereni) < 1000){                     // mereni po dobu jedne sekundy 
L2_merenaHodnota = analogRead(L2_pinTrafo);                    // mereni napeti na odporu
if (L2_merenaHodnota > L2_maximum){                            // nalezeni maxima
L2_maximum = L2_merenaHodnota;                                 // ulozeni noveho maxima
  }
 }
L2_vysledek = ((L2_maximum * 5.0) / 1024);                     // prevod vysledku na napeti ve Voltech
L2_vysledek = (L2_vysledek - 2.500);                           // vypocet hodnoty o stejnosmerne napeti prevodniku 2.500V
return L2_vysledek;                                            // vraceni vysledku funkce
}
float L3_NapetiSpickaSpicka(){                        
float L3_vysledek = 0;                                         // merici promenne
int L3_merenaHodnota = 0;                                      // merici promenne
int L3_maximum = 0;                                            // merici promenne
unsigned long zacatekMereni = millis();                        // ulozeni startovaciho casu
while ((millis() - zacatekMereni) < 1000){                     // mereni po dobu jedne sekundy 
L3_merenaHodnota = analogRead(L3_pinTrafo);                    // mereni napeti na odporu
if (L3_merenaHodnota > L3_maximum){                            // nalezeni maxima
L3_maximum = L3_merenaHodnota;                                 // ulozeni noveho maxima
  }
 }
L3_vysledek = ((L3_maximum * 5.0) / 1024);                     // prevod vysledku na napeti ve Voltech
L3_vysledek = (L3_vysledek - 2.500);                           // vypocet hodnoty o stejnosmerne napeti prevodniku 2.500V
return L3_vysledek;                                            // vraceni vysledku funkce
}

//podprogramy pro nastaveni lcd displeje
void LCDpoziceznaku(int row, int col){                         // nastaveni pozice zobrazeni znaku
if(row>1){row -= 2;                                            // porovnani zda je row vetsi nez jedna
LCD.write(0xFE); LCD.write((col + row*64 + 148));}             // vypocet pozice znaku pro treti a ctvrty radek
else{LCD.write(0xFE);LCD.write((col + row*64 + 128));}         // vypocet pozice znaku pro prvni a druhy radek
delay(LCDdelay);}                                              // konec podporgramu
void smazLCD(){                                                // smazani a inicializace lcd displeje
LCD.write(0xFE); LCD.write(0x01); delay(LCDdelay);}            // prikaz pro smazani
void podsviceniOn(){                                           // zapnuti podsviceni lcd displeje 
LCD.write(0xFE); LCD.write(0xE9);  delay(LCDdelay);}           // prikaz pro zapnuti
void podsviceniOff(){                                          // vypnuti podsviceni lcd displeje
LCD.write(0xFE); LCD.write(0xE8);  delay(LCDdelay);}           // prikaz pro vypnuti podsviceni displeje
void kursorOn(){                                               // zapnuti kursoru podtrzitka blikani
LCD.write(0xFE); LCD.write(0x0E); delay(LCDdelay);}            // prikaz pro zapnuti kursoru zobrazeni
void kursorOff(){                                              // prikaz pro vypnuti zobrazeni kursoru
LCD.write(0xFE); LCD.write(0x0C); delay(LCDdelay);}            // prikaz pro vypnuti kursoru
void posunvpravo(){                                            // zapsane znaky se zapisuji zleva doprava
LCD.write(0xFE); LCD.write(0x06); delay(LCDdelay);}            // prikaz pro posun zapsanych znaku
